<?php

/* ------------------------------------------------------------------------
  # cleanjs - Clean native javascript system plugin for Joomla
  # ------------------------------------------------------------------------
  # author    Prieco S.A.
  # copyright Copyright (C) 2012 Prieco.com. All Rights Reserved.
  # @license - http://http://www.gnu.org/licenses/gpl-3.0.html GNU/GPL
  # Websites: http://www.prieco.com
  # Technical Support:  Forum - http://www.prieco.com/en/forum/index.html
  ------------------------------------------------------------------------- */

defined('_JEXEC') or die('Restricted access');

jimport('joomla.plugin.plugin');

class plgSystemCleanJs extends JPlugin {

    function onBeforeRender() {
// Use only for site.
        $app = JFactory::getApplication();
        if ($app->isAdmin())
            return;

        $template = $app->getTemplate();
        $tplname = $this->params->def('tplname', null);
        if (!($template === $tplname))
            return;

        $document = & JFactory::getDocument();

        $jsfile1 = $this->params->def('jsfile1', null);
        if (!empty($jsfile1))
            $document->addScript($document->getBase() . $jsfile1, 'text/javascript', true);

        $jsfile2 = $this->params->def('jsfile2', null);
        if (!empty($jsfile2))
            $document->addScript($document->getBase() . $jsfile2, 'text/javascript', true);

        $jsfile3 = $this->params->def('jsfile3', null);
        if (!empty($jsfile3))
            $document->addScript($document->getBase() . $jsfile3, 'text/javascript', true);

        $fakeaddevent = $this->params->def('fakeaddevent', 1);
        if ($fakeaddevent)
            $document->addScriptDeclaration('if (Window.prototype.addEvent==null) Window.prototype.addEvent=function(){};', 'text/javascript');

        $fileremove = array();
        $fileremove[] = $this->params->def('jsfileremove1', null);
        $fileremove[] = $this->params->def('jsfileremove2', null);
        $fileremove[] = $this->params->def('jsfileremove3', null);
        $fileremove[] = $this->params->def('jsfileremove4', null);
        $fileremove[] = $this->params->def('jsfileremove5', null);
        $fileremove[] = $this->params->def('jsfileremove6', null);
        $fileremove[] = $this->params->def('jsfileremove7', null);
        $fileremove[] = $this->params->def('jsfileremove8', null);

        /* $fileremove[] = $this->params->def('cssfileremove1', null);
          $fileremove[] = $this->params->def('cssfileremove2', null);
          $fileremove[] = $this->params->def('cssfileremove3', null);
          $fileremove[] = $this->params->def('cssfileremove4', null);
          $fileremove[] = $this->params->def('cssfileremove5', null);
          $fileremove[] = $this->params->def('cssfileremove6', null);
          $fileremove[] = $this->params->def('cssfileremove7', null);
          $fileremove[] = $this->params->def('cssfileremove8', null); */
        $fileremove = array_filter($fileremove, 'strlen');

        $files = join('|', $fileremove);

        $doctype = $document->getType();
        if (($doctype == 'html') && (count($fileremove) > 0)) {
            $headerstuff = $document->getHeadData();
            reset($headerstuff['scripts']);

            $pattern = '/\/(' . $files . ')$/';
            foreach ($headerstuff['scripts'] as $key => $value) {
                if (preg_match($pattern, $key))
                    unset($headerstuff['scripts'][$key]);
            }

            if ($fakeaddevent) {
                $pattern_jcaption = '%window\.addEvent\(\'load\',\s*function\(\)\s*{\s*new\s*JCaption\(\'img.caption\'\);\s*}\);\s*%';
                $pattern_load = '%window\.addEvent\(\'load\',\s*function\(\)\s*{\s*}\);\s*%';
                $pattern_domready = '%window\.addEvent\(\'domready\',\s*function\(\)\s*{\s*}\);\s*%';

                foreach ($headerstuff['script'] as $key => $value) {
                    $script = $headerstuff['script'][$key];

                    $script = preg_replace($pattern_jcaption, '', $script);
                    $script = preg_replace($pattern_load, '', $script);
                    $script = preg_replace($pattern_domready, '', $script);

                    $headerstuff['script'][$key] = $script;
                }
            }

            $document->setHeadData($headerstuff);
        }
    }

}
